/* tslint:disable */
/* eslint-disable */
/**
 * opGUI - OpenAPI 3.0
 * Dummy description about the available endpoints Some useful links: - [The opGUI repository](https://gitlab.eclipse.org/eclipse/openpass/opgui) - [The documentation page](https://www.eclipse.org/openpass/content/html/index.html)
 *
 * The version of the OpenAPI document: 1.1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { exists, mapValues } from '../runtime';
/**
 * 
 * @export
 * @interface TreeNode
 */
export interface TreeNode {
    /**
     * 
     * @type {string}
     * @memberof TreeNode
     */
    name: string;
    /**
     * 
     * @type {Array<TreeNode>}
     * @memberof TreeNode
     */
    children?: Array<TreeNode>;
}

/**
 * Check if a given object implements the TreeNode interface.
 */
export function instanceOfTreeNode(value: object): boolean {
    let isInstance = true;
    isInstance = isInstance && "name" in value;

    return isInstance;
}

export function TreeNodeFromJSON(json: any): TreeNode {
    return TreeNodeFromJSONTyped(json, false);
}

export function TreeNodeFromJSONTyped(json: any, ignoreDiscriminator: boolean): TreeNode {
    if ((json === undefined) || (json === null)) {
        return json;
    }
    return {
        
        'name': json['name'],
        'children': !exists(json, 'children') ? undefined : ((json['children'] as Array<any>).map(TreeNodeFromJSON)),
    };
}

export function TreeNodeToJSON(value?: TreeNode | null): any {
    if (value === undefined) {
        return undefined;
    }
    if (value === null) {
        return null;
    }
    return {
        
        'name': value.name,
        'children': value.children === undefined ? undefined : ((value.children as Array<any>).map(TreeNodeToJSON)),
    };
}

